#ifndef __CLASS_DEBUG__
#define __CLASS_DEBUG__

#include "plattform.h"
#include <stdio.h>
#include <stdarg.h>

//! Die Klasse Debug dient dazu dem Benutzer Warnungen und Fehler anzuzeigen, die whrend des Programmablaufs auftreten.
class Debug
{
	public:
		static void Enable(bool enable);

		static void Error(const char* fmt, ...);
		static void Warning(const char* fmt, ...);
		static void Message(const char* fmt, ...);

	private:
		static void Output(const char* type, const char* fmt, va_list argp);

	private:

		static bool		sm_enable;
};

#endif

