#include "rnd.h"

dword Rnd::m_seed = 0;

void Rnd::SRand(dword seed)
{
	m_seed = seed;
	Rnd::Rand();
}

dword Rnd::Rand()
{
	static bool sinit = true;
	static dword k[4] = {0, 0, 0, 0};
	static dword v[2] = {0, 0};

	if(sinit)
	{
		Debug::Message("init rand: %i\n", m_seed);
		int count = 32 + (m_seed & 511);

		sinit = false;
		k[0] = m_seed;
		k[1] = m_seed << 8;
		k[2] = m_seed >> 8;
		k[3] = k[1] ^ k[2] ^ m_seed;
		v[0] = m_seed;
		v[1] = (m_seed << 16) ^ (m_seed >> 16);

		while (count--) Rnd::Rand();
	}

	Rnd::Encipher(v, v, k);

	return v[0];
}

void Rnd::Encipher(dword* v, dword* w, dword* k)
{
	dword y = v[0], z = v[1], sum = 0, delta = 0x9E3779B9;
   	dword a = k[0], b = k[1], c = k[2], d = k[3], n = 32;

   	while(n-- > 0)
   	{
    	sum += delta;
      	y += (z << 4)+a ^ z+sum ^ (z >> 5)+b;
      	z += (y << 4)+c ^ y+sum ^ (y >> 5)+d;
   	}
   	w[0] = y; w[1] = z;
}
