#ifndef RND_H
#define RND_H

#include "plattform.h"
#include "defines.h"
#include "debug.h"

#define RND_MAX			0xffffffff

//! Die Klasse Rnd ist fr die Erzeugung von Zufallszahlen zustndig. 
/*! Sie beruht auf dem Tiny Encryption Algorithm.
Nhere Informationen zu dem verwendeten Tiny Encryption Algorithmus findet man unter
http://www.ftp.cl.cam.ac.uk/ftp/papers/djw-rmn/djw-rmn-tea.html.
*/
class Rnd
{
	public:
		static void SRand(dword seed);
		static dword Rand();

	private:
		static void Encipher(dword* v, dword* w, dword* k);


	private:
		static dword m_seed;
};

#endif
