#include "xml_lang.h"
#include "generator.h"

#include <sstream>

Xml_lang::Xml_lang (  ){
}

Xml_lang::~Xml_lang (  ){
}

std::string subCode() {
	std::string code;
	//! Whle die Lnge des Sub-Codes. Der Sub-Code kann die Zeichen a-z und A-Z enthalten.
  	int length = (int) (Generator::rnd() * 14) + 1;
  	
	for (int j = 0; j < length; )
	{
  		int current = (int) (Generator::rnd() * 122);
  		if ( ((current >= 65) && (current <= 90))  || ((current >= 97) && (current <= 122)))
  		{
  			code += char(current);
  			++j;
		}
		
   	}
   	return code;
}

//! Diese Methode whlt einen Sub-Code aus dem ISO-Standard.
std::string isoSubCode() {
	int langCode = (int) (Generator::rnd() * 238) + 1;
	switch (langCode) {
		case 1: return "af";
	    case 2: return "al";
    	case 3: return"dz";
   		case 4: return "as";
		case 5: return "ad";
        case 6: return "ao";
       	case 7: return "ai";
 		case 8: return "aq";
		case 9: return "ag";
		case 10: return "ar";
		case 11: return "am";
    	case 12: return "aw";
   		case 13: return "au";
		case 14: return "at";
		case 15: return "az";
   		case 16: return "bs";
		case 17: return "bh";
		case 18: return "bb";
		case 19: return "by";
		case 20: return"be";
		case 21: return "bz";
		case 22: return "bj";
		case 23: return "bm";
		case 24: return "bt";
		case 25: return "bo";
		case 26: return "ba";
		case 27: return "bw";
		case 28: return "bv";
		case 29: return "br";
		case 30: return "io";
		case 31: return "bn";
	    case 32: return "bg";
    	case 33: return "bf";
   		case 34: return "bi";
		case 35: return "kh";
        case 36: return "cm";
       	case 37: return "ca";
 		case 38: return "cv";
		case 39: return "ky";
		case 40: return "cf";
		case 41: return "td";
    	case 42: return "cl";
   		case 43: return "cn";
		case 44: return "cx";
		case 45: return "cc";
   		case 46: return "co";
		case 47: return "km";
		case 48: return "cg";
		case 49: return "cd";
		case 50: return "ck";
		case 51: return "cr";
		case 52: return "ci";
		case 53: return "hr";
		case 54: return "cu";
		case 55: return "cy";
		case 56: return "cz";
		case 57: return "dk";
		case 58: return "dj";
		case 59: return "dm";
		case 60: return "do";
		case 61: return "eg";
	    case 62: return "sv";
    	case 63: return "gq";
   		case 64: return "er";
		case 65: return "ee";
        case 66: return "et";
       	case 67: return "fk";
 		case 68: return "fo";
		case 69: return "fj";
		case 70: return "fi";
		case 71: return "fr";
    	case 72: return "gf";
   		case 73: return "pf";
		case 74: return "tf";
		case 75: return "ga";
   		case 76: return "gm";
		case 77: return "ge";
		case 78: return "de";
		case 79: return "gh";
		case 80: return "gi";
		case 81: return "gr";
		case 82: return "gl";
		case 83: return "gd";
		case 84: return "gp";
		case 85: return "gu";
		case 86: return "gt";
		case 87: return "gn";
		case 88: return "gw";
		case 89: return "gy";
		case 90: return "ht";
		case 91: return "hm";
   		case 92: return "va";
		case 93: return "hn";
		case 94: return "hk";
		case 95: return "hu";
		case 96: return "is";
		case 97: return "in";
		case 98: return "id";
		case 99: return "ir";
		case 100: return "iq";
		case 101: return "ie";
		case 102: return "il";
		case 103: return "it";
		case 104: return "jm";
		case 105: return "jp";
		case 106: return "jo";
		case 107: return "kz";
	    case 108: return "ke";
    	case 109: return "ki";
   		case 110: return "kp";
		case 111: return "kr";
        case 112: return "kw";
       	case 113: return "kg";
 		case 114: return "la";
		case 115: return "lv";
		case 116: return "lb";
		case 117: return "ls";
    	case 118: return "lr";
   		case 119: return "ly";
		case 120: return "li";
		case 121: return "lt";
   		case 122: return "lu";
		case 123: return "mo";
		case 124: return "mk";
		case 125: return "mg";
		case 126: return "mw";
		case 127: return "my";
		case 128: return "mv";
		case 129: return "ml";
		case 130: return "mt";
		case 131: return "mh";
		case 132: return "mq";
		case 133: return "mr";
		case 134: return "mu";
		case 135: return "yt";
		case 136: return "mx";
		case 137: return "fm";
	    case 138: return "md";
    	case 139: return "mc";
   		case 140: return "mn";
		case 141: return "ms";
        case 142: return "ma";
       	case 143: return "mz";
 		case 144: return "mm";
		case 145: return "na";
		case 146: return "nr";
		case 147: return "np";
    	case 148: return "nl";
   		case 149: return "an";
		case 150: return "nc";
		case 151: return "nz";
   		case 152: return "ni";
		case 153: return "ne";
		case 154: return "ng";
		case 155: return "nu";
		case 156: return "nf";
		case 157: return "mp";
		case 158: return "no";
		case 159: return "om";
		case 160: return "pk";
		case 161: return "pw";
		case 162: return "ps";
		case 163: return "pa";
		case 164: return "pg";
		case 165: return "py";
		case 166: return "pe";
		case 167: return "ph";
	    case 168: return "pn";
    	case 169: return "pl";
   		case 170: return "pt";
		case 171: return "pr";
        case 172: return "qa";
       	case 173: return "re";
 		case 174: return "ro";
		case 175: return "ru";
		case 176: return "rw";
		case 177: return "sh";
    	case 178: return "kn";
   		case 179: return "lc";
		case 180: return "pm";
		case 181: return "vc";
   		case 182: return "ws";
		case 183: return "sm";
		case 184: return "st";
		case 185: return "sa";
		case 186: return "sn";
		case 187: return "sc";
		case 188: return "sl";
		case 189: return "sg";
		case 190: return "sk";
		case 191: return "si";
		case 192: return "sb";
		case 193: return "so";
		case 194: return "za";
		case 195: return "gs";
		case 196: return "es";
		case 197: return "lk";
	    case 198: return "sd";
    	case 199: return "sr";
   		case 200: return "sj";
		case 201: return "sz";
        case 202: return "se";
       	case 203: return "ch";
 		case 204: return "sy";
		case 205: return "tw";
		case 206: return "tj";
		case 207: return "tz";
    	case 208: return "th";
   		case 209: return "tl";
		case 210: return "tg";
		case 211: return "tk";
   		case 212: return "to";
		case 213: return "tt";
		case 214: return "tn";
		case 215: return "tr";
		case 216: return "tm";
		case 217: return "tc";
		case 218: return "tv";
		case 219: return "ug";
		case 220: return "ua";
		case 221: return "ae";
		case 222: return "gb";
		case 223: return "us";
		case 224: return "um";
		case 225: return "uy";
		case 226: return "uz";
		case 227: return "vu";
   		case 228: return "ve";
		case 229: return "vn";
		case 230: return "vg";
		case 231: return "vi";
		case 232: return "wf";
		case 233: return "eh";
		case 234: return "ye";
		case 235: return "yu";
		case 236: return "zm";
		case 237: return "zw";
		case 238: return "bd";
		case 239: return "ec";
		default: return "de";
	}
}

//! Generiert einen Sprach-Code nach den folgenden Regeln:
//! LanguageID ::= Langcode ('-' Subcode)*
//! Langcode ::= ISO639Code | UserCode
//! ISO639Code ::= ([a-z] | [A-Z]) ([a-z] | [A-Z])
//! UserCode ::= ('x' | 'X') '-' ([a-z] | [A-Z])+
//! Subcode ::= ([a-z] | [A-Z])+
std::string Xml_lang::ToString (  ) {
	
  std::stringstream lang;
  double rand = Generator::rnd();
  
  //! Whle einen selbst definierten Code oder einen ISO-Code
  if (rand < .33)
  {
  	double rand2 = Generator::rnd();
    	if (rand2 < .5)
	    lang << "x-";
    	else
    		lang << "X-";
   	lang << subCode();
  }
  else 
  {
  	//! Whle einen aus dem ISO 639 Standard
  	int langCode = (int)(Generator::rnd() * 135) + 1;
    switch(langCode)	{
	    	case 1: lang << "aa";
			break;
	    	case 2: lang << "ab";
			break;
    		case 3: lang <<"af";
			break;
   		case 4: lang << "am";
			break;
		case 5: lang << "ar";
			break;
        	case 6: lang << "as";
			break;
       		case 7: lang << "ay";
			break;
 		case 8: lang << "az";
			break;
		case 9: lang << "ba";
			break;
		case 10: lang << "be";
			break;
		case 11: lang << "bg";
			break;
    		case 12: lang << "bh";
			break;
   		case 13: lang << "bi";
			break;
		case 14: lang << "bn";
			break;
		case 15: lang << "bo";
			break;
   		case 16: lang << "br";
			break;
		case 17: lang << "ca";
			break;
		case 18: lang << "co";
			break;
		case 19: lang << "cs";
			break;
		case 20: lang << "cy";
			break;
		case 21: lang << "da";
			break;
		case 22: lang << "de";
			break;
		case 23: lang << "dz";
			break;
		case 24: lang << "el";
			break;
		case 25: lang << "en";
			break;
		case 26: lang << "eo";
			break;
		case 27: lang << "es";
			break;
		case 28: lang << "et";
			break;
		case 29: lang << "eu";
			break;
		case 30: lang << "fa";
			break;
		case 31: lang << "fi";
			break;
	    	case 32: lang << "fj";
			break;
    		case 33: lang << "fo";
			break;
   		case 34: lang << "fr";
			break;
		case 35: lang << "fy";
			break;
        	case 36: lang << "ga";
			break;
       		case 37: lang << "gd";
			break;
 		case 38: lang << "gl";
			break;
		case 39: lang << "gn";
			break;
		case 40: lang << "gu";
			break;
		case 41: lang << "ha";
			break;
    		case 42: lang << "hi";
			break;
   		case 43: lang << "hr";
			break;
		case 44: lang << "hu";
			break;
		case 45: lang << "hy";
			break;
   		case 46: lang << "ia";
			break;
		case 47: lang << "ie";
			break;
		case 48: lang << "ik";
			break;
		case 49: lang << "in";
			break;
		case 50: lang << "is";
			break;
		case 51: lang << "it";
			break;
		case 52: lang << "iw";
			break;
		case 53: lang << "ja";
			break;
		case 54: lang << "ji";
			break;
		case 55: lang << "jw";
			break;
		case 56: lang << "ka";
			break;
		case 57: lang << "kk";
			break;
		case 58: lang << "kl";
			break;
		case 59: lang << "km";
			break;
		case 60: lang << "kn";
			break;
		case 61: lang << "ko";
			break;
	   	 case 62: lang << "ks";
			break;
    		case 63: lang << "ku";
			break;
   		case 64: lang << "ky";
			break;
		case 65: lang << "la";
			break;
      	 	 case 66: lang << "ln";
			break;
      	 	case 67: lang << "lo";
			break;
 		case 68: lang << "lt";
			break;
		case 69: lang << "lv";
			break;
		case 70: lang << "mg";
			break;
		case 71: lang << "mi";
			break;
    		case 72: lang << "mk";
			break;
   		case 73: lang << "ml";
			break;
		case 74: lang << "mn";
			break;
		case 75: lang << "mo";
			break;
   		case 76: lang << "mr";
			break;
		case 77: lang << "ms";
			break;
		case 78: lang << "mt";
			break;
		case 79: lang << "my";
			break;
		case 80: lang << "na";
			break;
		case 81: lang << "ne";
			break;
		case 82: lang << "nl";
			break;
		case 83: lang << "no";
			break;
		case 84: lang << "oc";
			break;
		case 85: lang << "om";
			break;
		case 86: lang << "or";
			break;
		case 87: lang << "pa";
			break;
		case 88: lang << "pl";
			break;
		case 89: lang << "ps";
			break;
		case 90: lang << "pt";
			break;
		case 91: lang << "qu";
			break;	
   		case 92: lang << "rm";
   			break;
		case 93: lang << "rn";
			break;
		case 94: lang << "ro";
			break;
		case 95: lang << "ru";
			break;
		case 96: lang << "rw";
			break;
		case 97: lang << "sa";
			break;
		case 98: lang << "sd";
			break;
		case 99: lang << "sg";
			break;
		case 100: lang << "sh";
			break;
		case 101: lang << "si";
			break;
		case 102: lang << "sk";
			break;
		case 103: lang << "sl";
			break;
		case 104: lang << "sm";
			break;
		case 105: lang << "sn";
			break;
		case 106: lang << "so";
			break;
		case 107: lang << "sq";
	    		break;
	    	case 108: lang << "sr";
	    		break;
    		case 109: lang << "ss";
    			break;
   		case 110: lang << "st";
   			break;
		case 111: lang << "su";
			break;
       		 case 112: lang << "sv";
        		break;
       		case 113: lang << "sw";
       			break;
 		case 114: lang << "ta";
 			break;
		case 115: lang << "te";
			break;
		case 116: lang << "tg";
			break;
		case 117: lang << "th";
			break;	
    		case 118: lang << "ti";
    			break;
   		case 119: lang << "tk";
   			break;
		case 120: lang << "tl";
			break;
		case 121: lang << "tn";
			break;	
   		case 122: lang << "to";
   			break;
		case 123: lang << "tr";
			break;
		case 124: lang << "ts";
			break;
		case 125: lang << "tt";
			break;
		case 126: lang << "tw";
			break;
		case 127: lang << "uk";
			break;
		case 128: lang << "ur";
			break;
		case 129: lang << "uz";
			break;
		case 130: lang << "vi";
			break;
		case 131: lang << "vo";
			break;
		case 132: lang << "wo";
			break;
		case 133: lang << "xh";
			break;
		case 134: lang << "yo";
			break;
		case 135: lang << "zh";
			break;
		case 136: lang << "zu";
			break;
		default: lang << "de";
	}
	//! Entscheide, ob der ISO-Code Sub-Codes hat, wenn ja, dann muss der erste ISO definiert sein.
	if (Generator::rnd() < 0.5)
	{
		lang << "-" << isoSubCode();
	}
 	else
 		return lang.str();
  }
  //! Erzeuge weitere Sub-Codes mit einer bestimmten Wahrscheinlichkeit.
  for (double i = 0.3; Generator::rnd() >= i; i += 0.1) {
  	lang << "-";
  	lang << subCode();
  }
  return lang.str();
}
