#ifndef ELEMENT_H
#define ELEMENT_H

#include "plattform.h"
#include <string>
#include <map>


//! Die Klasse Element ist eine abstrakte Basisklasse und stellt einen gemeinsamen Typ fr die Elemente des Baumes zur Verfgung.
class Element
{
public:
	std::string m_tagname;
	Element* m_parent;
  public:
  // Associations
  // Attributes
  int m_spaces;
  // Operations
  Element();
  virtual ~Element();
  virtual std::string ToString (  ) = 0;
  virtual void addChild ( Element* new_elem )=0;
  virtual std::map< std::string, bool > get_parents( ) = 0;
};

#endif
