#ifndef WML_INTERFACE_H
#define WML_INTERFACE_H

#include "plattform.h"
#include "wml_tree.h"
#include "generator.h"
#include "confobject.h"
#include "inifileparser.h"

#include <string>

//! Die Klasse WML_Interface ist die Verbindung zwischen den einzelnen Komponenten des Softwaresystems.
class WML_Interface
{
  // Associations
   WML_Tree* wml_tree;

   //FileIO Ein-/Ausgabe;
  // Attributes
  private:
    dword seed;
    Generator* generator;
    FileIO* config;
    std::string timestamp;
  // Operations
  public:
    WML_Interface ( std::string );
    WML_Interface ( std::string, dword _seed );
    ~WML_Interface (  );
    std::string output ( );
    WML_Tree* build_tree (  );
    dword get_seed ();
    void setTimestamp ( std::string ts);

    bool IsReady() const;
};

#endif
