#include <assert.h>
#include <cppunit/ui/text/TestRunner.h>
#include "ComponentTest.h"

int main () {
  CppUnit::TextUi::TestRunner runner;
  runner.addTest( TagTest::suite() );
  runner.addTest( LengthTest::suite() );
  runner.addTest( VdataTest::suite() );
  runner.addTest( HrefTest::suite() );
  runner.addTest( Xml_langTest::suite() );
  runner.addTest( Xml_spaceTest::suite() );
  runner.addTest( ClassTest::suite() );
  runner.addTest( IdTest::suite() );
  runner.addTest( IAlignTest::suite() );
  runner.addTest( TAlignTest::suite() );
  runner.addTest( WrapmodeTest::suite() );
  runner.addTest( ContentTypeTest::suite() );
  runner.addTest( WmlTreeTest::suite() );
  runner.addTest( ConfObjectTest::suite() );
  runner.addTest( Wml_InterfaceTest::suite() );
  runner.addTest( GeneratorTest::suite() );
  runner.run();
  return 0;
}
